#!/usr/local/bin/ipython3
import astropy,os,scipy,scipy.interpolate,sys,scipy.signal,math
#import matplotlib.pyplot as plt
import numpy as np
from astropy.io import fits
from scipy import interpolate
from scipy.interpolate import Rbf
from scipy.signal import savgol_filter
from scipy.ndimage import gaussian_filter1d
#from matplotlib import cm

#os.system('ls 20160412/Bias/d7491.0*.fits > bias_fits.lst')
#os.system('ls 20160412/Flat/d7491.0*.fits > flat_fits.lst')

gain=np.empty((16,10000))
ron=np.empty((16,10000))

mgain=np.empty((16))
mron=np.empty((16))
sgain=np.empty((16))
sron=np.empty((16))

fsig=3.0

for line in open("flat_fits.lst"):
    line=line.strip("\n")
    exptime=fits.getval(line,'EXPTIME',0)
#    print(line,exptime)

j=0
for line_bias1 in open("bias_fits.lst"):
    line_bias1=line_bias1.strip("\n")
    for line_bias2 in open("bias_fits.lst"):
        line_bias2=line_bias2.strip("\n")
        for line_flat1 in open("flat_fits.lst"):
            line_flat1=line_flat1.strip("\n")
            for line_flat2 in open("flat_fits.lst"):
                line_flat2=line_flat2.strip("\n")

#                print(line_bias1,line_bias2,line_flat1,line_flat2)
                
                if(line_bias1!=line_bias2)&(line_flat1!=line_flat2):
                    bias1=fits.open(line_bias1)
                    bias2=fits.open(line_bias2)
                    flat1=fits.open(line_flat1)
                    flat2=fits.open(line_flat2)

                    for i in range(16):
                        data1=bias1[i+1].data
                        data2=bias2[i+1].data
                        data3=np.empty((2068,2036),dtype=np.float32)

                        data4=flat1[i+1].data
                        data5=flat2[i+1].data
                        data6=np.empty((2068,2036),dtype=np.float32)

                        data3=np.float32(data1)-np.float32(data2)
                        data6=np.float32(data4)-np.float32(data5)

                        c1,low,upp=scipy.stats.sigmaclip(data1[500:1500,500:1500])
                        mbias1=np.median(c1)
                        c2,low,upp=scipy.stats.sigmaclip(data2[500:1500,500:1500])
                        mbias2=np.median(c2)
                        d1,low,upp=scipy.stats.sigmaclip(data4[500:1500,500:1500])
                        mflat1=np.median(d1)
                        d2,low,upp=scipy.stats.sigmaclip(data5[500:1500,500:1500])
                        mflat2=np.median(d2)
                        e1,low,upp=scipy.stats.sigmaclip(data3[500:1500,500:1500])
                        sbias=np.std(e1)
                        e2,low,upp=scipy.stats.sigmaclip(data6[500:1500,500:1500])
                        sflat=np.std(e2)

                        print(i+1,mbias1,mbias2,mflat1,mflat2,sbias,sflat)

                        gain[i,j]=(mflat1+mflat2-mbias1-mbias2)/(sflat**2.+sbias**2.)
                        ron[i,j]=np.std(c1)*gain[i,j]
                        print(line_bias1)
                        print(i+1,j,gain[i,j],ron[i,j],np.std(c1))
#
#                        if(i==14)or(i==15):
#                            print(i,j,mflat1,mflat2,mbias1,mbias2,sflat,sbias,gain[i,j],ron[i,j])

                    j=j+1

                    flat2.close()
                    flat1.close()

                    bias2.close()
                    bias1.close()

                num=j-1
for i in range(16):
    mgain[i]=np.median(gain[i,:num])
    sgain[i]=np.std(gain[i,:num])
    mron[i]=np.median(ron[i,:num])
    sron[i]=np.std(ron[i,:num])

    print(' HDU ',i+1,mgain[i],mron[i])

#    print(num)
#    print(gain[i,:num],ron[i,:num])
